summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorThomas Klute <thomas2.klute@uni-dortmund.de>2017-09-21 11:00:33 +0200
committerNikos Mavrogiannopoulos <nmav@gnutls.org>2017-09-23 10:38:54 +0200
commitf7aa74440684891fca57ac57f14a198db59006f0 (patch)
treed7c65fa764e39fca05b4df2ad5e77612064bc0fd
parent3ee218993521a69b39b9fc5704d02eb56b7246bb (diff)
downloadgnutls-f7aa74440684891fca57ac57f14a198db59006f0.tar.gz
tests: New test for SNI parsing during cache-based session resumption
Signed-off-by: Thomas Klute <thomas2.klute@uni-dortmund.de> Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>
-rw-r--r--tests/Makefile.am3
-rwxr-xr-xtests/sni-resume.sh80
2 files changed, 82 insertions, 1 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index e38a8b35be..250f42640b 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -317,7 +317,8 @@ dist_check_SCRIPTS += fastopen.sh pkgconfig.sh starttls.sh starttls-ftp.sh start
starttls-lmtp.sh starttls-pop3.sh starttls-nntp.sh starttls-sieve.sh \
ocsp-tests/ocsp-tls-connection ocsp-tests/ocsp-must-staple-connection \
ocsp-tests/ocsp-test cipher-listings.sh sni-hostname.sh server-multi-keys.sh \
- psktool.sh ocsp-tests/ocsp-load-chain gnutls-cli-save-data.sh gnutls-cli-debug.sh
+ psktool.sh ocsp-tests/ocsp-load-chain gnutls-cli-save-data.sh gnutls-cli-debug.sh \
+ sni-resume.sh
if ENABLE_PKCS11
diff --git a/tests/sni-resume.sh b/tests/sni-resume.sh
new file mode 100755
index 0000000000..f1af5fab0f
--- /dev/null
+++ b/tests/sni-resume.sh
@@ -0,0 +1,80 @@
+#!/bin/sh
+
+# Copyright (C) 2017 Thomas Klute
+#
+# Author: Thomas Klute
+#
+# This file is part of GnuTLS.
+#
+# GnuTLS is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GnuTLS is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>
+
+srcdir="${srcdir:-.}"
+SERV="${SERV:-../src/gnutls-serv${EXEEXT}}"
+CLI="${CLI:-../src/gnutls-cli${EXEEXT}}"
+unset RETCODE
+
+if ! test -x "${SERV}"; then
+ exit 77
+fi
+
+if ! test -x "${CLI}"; then
+ exit 77
+fi
+
+if test "${WINDIR}" != ""; then
+ exit 77
+fi
+
+if ! test -z "${VALGRIND}"; then
+ VALGRIND="${LIBTOOL:-libtool} --mode=execute ${VALGRIND} --error-exitcode=15"
+fi
+
+SERV="${SERV} -q"
+
+. "${srcdir}/scripts/common.sh"
+
+PRIORITY="NORMAL:-VERS-TLS-ALL:+VERS-TLS1.2:+ANON-ECDH"
+
+echo "Checking if the SNI extension is parsed in gnutls-serv during" \
+ "cache-based session resumption"
+
+TMPFILE="servoutput.$$.tmp"
+
+eval "${GETPORT}"
+launch_server $$ --echo --priority ${PRIORITY} --sni-hostname-fatal \
+ --sni-hostname server.example.com --noticket 2>${TMPFILE}
+PID=$!
+wait_server ${PID}
+
+${VALGRIND} "${CLI}" -p "${PORT}" 127.0.0.1 --sni-hostname server.example.com \
+ --priority ${PRIORITY} </dev/null >/dev/null \
+ --resume \
+ || fail ${PID} "connection and resumption should have succeeded!"
+
+kill ${PID}
+wait
+
+ret=0
+cat "${TMPFILE}"
+# The --sni-hostname-fatal option rejects only clients which send a
+# server name that does not match the expected one, not clients that
+# do not send an SNI extension at all. Check if the server logged a
+# missing extension.
+if grep "client did not include SNI extension" "${TMPFILE}" >/dev/null; then
+ ret=1
+ echo "SNI data missing unexpectedly!"
+fi
+rm "${TMPFILE}"
+
+exit ${ret}